#include <stdio.h>;
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <ctime>
#include "matrix.h"
#include <iomanip>


using namespace std;
void bMarginCalculator(Matrix , int *, int *, int , int );

//using X0 and A matrix to calculatt B vector/////////////
void bMarginCalculator(Matrix A, int *b, int *X0, int m, int n)
{
	for (int i=0; i<m; i++)
	{
		b[i]=0;
		for (int j=0; j<n; j++)
		{
			b[i]+=A.rowVectors[i].elements[j] * X0[j];
			
		}
	}
	
	
}
//Calculate the margin of exch A //

void marginAfunc(Matrix A, int * marginA, int m, int n)
{
	for (int i=0; i<n; i++)
	{
		marginA[i]=0;
		for (int j=0; j<m; j++)  marginA[i]+=A.rowVectors[j].elements[i];
	}
	
}


//calculate the lowbound and uobound using IP(INTERGER)
float boundIP(int *b,Matrix A, int m, int n, float l,const char * dir)
{
	//generate ls file for lp_solve;
	int marginA[n];
	marginAfunc(A, marginA, m, n);
	int count=0;
	ofstream out("file2.ls");
	out << dir<<": "<<"x1" <<";" <<endl;
	for(int i = 0; i < m; i++)
	{
		count = 0;     
		for(int j =     0; j < n; j++)
		{      
			if(A.rowVectors[i].elements[j] != 0)
			{      
				// add the sign"+" or "-" for exch elements
				if(count != 0)
				{      
					if(A.rowVectors[i].elements[j] > 0)
						out << "+";    
					else if(A.rowVectors[i].elements[j]< 0) out << "-";
				}
				
				
				if(fabs(A.rowVectors[i].elements[j]) == 1) out << "x" << (j + 1);              
				else out << fabs(A.rowVectors[i].elements[j]) << "x" << (j + 1);       
				count++;  
			}
			
		}
		if (count!=0) out<<"="<<b[i]<<";"<<endl;
	}
	count=0;
	out<<"int ";
	for(int j =0; j < n; j++)
	{      
		//	cout << marginA[j]<<" ";
		if(marginA[j] != 0)
		{      
			
			if(count!=0) out << ", "<<"x" << (j + 1);             
			else out << "x" << (j + 1);
			
		}
		count++;
		
	}
	out<<";"<<endl;	
	
	
	
	char commond2[270];
	sprintf(commond2, "./lp_solve -S1 file2.ls >output.txt ");
	//cout << commond2;
	system(commond2);
	
	char buffer1[2048];
	char buffer2[2048];
	
	ifstream fin("output.txt");
	if(!fin)
	{
		cerr << "Error on reading the input file." << endl;
		exit(0);
	}
	int i=0;
	while (fin)
	{
		
		if (i==1) fin.getline(buffer1,50);  //cout << buffer1<<endl;
		else  fin.getline(buffer2,50); //cout << buffer2<<endl;
		i++;
	}
	//      cout << buffer1<< " " ;
	sscanf(buffer1, "Value of objective function: %f", &l);
	//    cout<< l<< endl;
	return l;
}

//generate one integer//
int RandonInteger (int lowbound,int upbound)
{
	int onecell;
	onecell=lowbound+rand()%(upbound-lowbound+1);
	return onecell;
}
/*________________________________________________________________*/

double oneLoop(int m, int n, Matrix A,int *b, int *bnew)
{
	
	int X[n];
	const char *dir1="max";
	const char *dir2="min";
	
	for (int i=0; i<n; ++i) X[i]=0;
	
	//begain generate the random number;
	int lowboundIP=0;
	int upboundIP=0;
	double oneN=1;
	for (int k=0;k<n;k++)
	{  
		int nnew=n-k;
		Matrix Anew(m, nnew);
		for(int i = 0; i < m; i++) for(int j = 0; j < nnew; j++) Anew.rowVectors[i].elements[j]=A.rowVectors[i].elements[j+k];
		float l=0;
		
		if (lowboundIP>upboundIP)
		{
			X[k]=0;
			oneN=-2;
			
		}
		else {
			upboundIP=boundIP( bnew, Anew, m, nnew,l,dir1);
			l=0;
			lowboundIP=boundIP( bnew, Anew, m, nnew,l,dir2);
			oneN=oneN*(upboundIP-lowboundIP+1);//calculate the sample size;
			
			if (upboundIP<lowboundIP)
			{
				cerr<<"lowbound larger than upbound"<<lowboundIP<<" "<<upboundIP<<endl;
				X[k]=0;
			}
			else if (lowboundIP==upboundIP) X[k]=lowboundIP;
			else X[k]=RandonInteger(lowboundIP, upboundIP);
			// cout << X[k]<<endl;
			//updat b vector;
			//printf("the updataed b at the %d  step is ", k);
			for(int i = 0; i < m; ++i) 
			{
				bnew[i]=bnew[i]-A.rowVectors[i].elements[k] * X[k];
				//	      cout << bnew[i]<<" ";
			}
			//cout << endl;
		}
	}
	int bcheck[m],bcheckresult[m],RowColcheck=0;
	for (int i=0;i<m;i++)
	{
		bcheck[i]=0;
		for(int j=0;j<n;j++)
		{
			bcheck[i]=bcheck[i]+A.rowVectors[i].elements[j] * X[j];
		}
		//              cout << bcheck[i]<<" "<<b[i]<<endl;
	}
	
	for (int i=0; i<m;i++)  bcheckresult[i]=(bcheck[i]-b[i])*(bcheck[i]-b[i]);
	for(int i = 0; i < m; i++)  RowColcheck += bcheckresult[i];
	
	int elementCheck=0;
	for (int i=0; i<n ; i++) {
		if (X[i]<0) elementCheck++;
	}
	
	//      cout<<endl<<RowColcheck<<" "<<elementCheck;
	if (RowColcheck > 0 || elementCheck > 0)  oneN=-2;
	
	
	
	return oneN;
}


/*****************************************************************************/
//Using one sample to run N times
double Nloop(int m, int n, Matrix A,int *b, int N,int *result_temp1, double *result_temp2)
{
	
	double N1=0;
	double one;
	int bnew[m];
	double sum;
	int count;
	for (int i=0;i<N;i++)
	{
		for (int i=0;i<m;i++) bnew[i]=b[i];
		one=oneLoop( m, n, A,b,bnew);          
		if (one <=0) count++;
		else { sum+=one;N1++;}
	}
	double succeN;
	
	if (N1>0) succeN=sum/N;
	if (N1==0) succeN=-1;
	
	*result_temp1=count;
	*result_temp2=succeN;
    return 0;
}

/**********************************************************************************/
double count;
double succeN;
int main(int argc, char *argv[])
{
	srand(time(0));
	int startTime=time(0);
	//input the second file; read A matrix;
	
	int m,n;
	
	char filenameA[127];
	strcpy(filenameA, argv[1]);
	
	ifstream inputA(filenameA);
	if(!inputA)
	{
		cerr << "Error on reading the A matrix." << endl;
		exit(0);
	}
	
	
	inputA >> m>>n;
	Matrix A(m,n); 
	
	for(int i=0;i<m;i++)
	{
		for (int j=0;j<n;j++)
		{
			inputA >> A.rowVectors[i].elements[j];
			//                      cout << A.rowVectors[i].elements[j]<<" ";
		}
		//                      cout<< endl;
	}
	
	
	
	//input the second file; read x0 vector or generate X0 vector;
	
	int b[m];
	int N;
	int X0[n];
	
	
	
	N=atof(argv[2]);

	char filenameX0[127];
	strcpy(filenameX0, argv[3]);
	
	ifstream inputX0(filenameX0);
	

	if(!inputX0)
	{
		cerr << "Error on reading observed table." << endl;
		exit(0);
	}
	cout << "The observed table is: "<<endl;
	
	for (int i=0;i<n;i++){
		X0[i]=0; inputX0>> X0[i];
		cout <<X0[i]<<" ";
	}
	cout << endl<<endl;
	bMarginCalculator(A, b,X0, m, n);
	int  result_temp1=0;
	double result_temp2=0;
	Nloop(m, n, A,b, N,&result_temp1, &result_temp2);
	int endTime=time(0);
	double duration=endTime-startTime;
	cout << "The duration time and unstatisfied example is  "<<duration<<" seconds "<<endl<<endl;
	cout << "The unstatisfied number of sampling is   "<<result_temp1<<endl<<endl;
	cout<<  "The estimated sample size is  "<<setprecision (20)<< result_temp2<<endl;
	cout << endl;
	return 0;
}


















