#include <stdio.h>;
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <ctime>
#include "matrix.h"
#include <iomanip>


using namespace std;
void bMarginCalculator(Matrix , int *, int *, int , int );

//using observed table X0 and design matrix to calculate the constrain  B vector
void bMarginCalculator(Matrix A, int *b, int *X0, int m, int n)
{
	for (int i=0; i<m; i++)
	{
		b[i]=0; 
		for (int j=0; j<n; j++)
		{
			b[i]+=A.rowVectors[i].elements[j] * X0[j];//B=AX;
			
		}
	}
	
	
}
//Calculate the row sum of A matrix 

void marginAfunc(Matrix A, int * marginA, int m, int n)
{
	for (int i=0; i<n; i++)
	{
		marginA[i]=0;
		for (int j=0; j<m; j++)  marginA[i]+=A.rowVectors[j].elements[i];
	}
	
}


//calculate the lowbound and uobound using IP(INTERGER)
float lp_bound_IP(int *b,Matrix A, int m, int n, float l,const char * dir)
{
	//generate ls file for lp_solve;
	int marginA[n];
	marginAfunc(A, marginA, m, n);
	int count=0;
	ofstream out("file2.ls");
	out << dir<<": "<<"x1" <<";" <<endl;
	for(int i = 0; i < m; i++)
	{
		count = 0;     
		for(int j =     0; j < n; j++)
		{      
			if(A.rowVectors[i].elements[j] != 0)
			{      
				// add the sign"+" or "-" for exch elements
				if(count != 0)
				{      
					if(A.rowVectors[i].elements[j] > 0)
						out << "+";    
					else if(A.rowVectors[i].elements[j]< 0) out << "-";
				}
				
				
				if(fabs(A.rowVectors[i].elements[j]) == 1) out << "x" << (j + 1);              
				else out << fabs(A.rowVectors[i].elements[j]) << "x" << (j + 1);       
				count++;  
			}
			
		}
		if (count!=0) out<<"="<<b[i]<<";"<<endl;
	}
	count=0;
	out<<"int ";
	for(int j =0; j < n; j++)
	{      
		//	cout << marginA[j]<<" ";
		if(marginA[j] != 0)
		{      
			
			if(count!=0) out << ", "<<"x" << (j + 1);             
			else out << "x" << (j + 1);
			
		}
		count++;
		
	}
	out<<";"<<endl;	
	
	
	
	char commond2[270];
	sprintf(commond2, "./lp_solve -S1 file2.ls >output.txt ");
	//cout << commond2;
	system(commond2);
	
	char buffer1[2048];
	char buffer2[2048];
	
	ifstream fin("output.txt");
	if(!fin)
	{
		cerr << "Error on reading the input file." << endl;
		exit(0);
	}
	int i=0;
	while (fin)
	{
		
		if (i==1) fin.getline(buffer1,50);  //cout << buffer1<<endl;
		else  fin.getline(buffer2,50); //cout << buffer2<<endl;
		i++;
	}
	//      cout << buffer1<< " " ;
	sscanf(buffer1, "Value of objective function: %f", &l);
	//    cout<< l<< endl;
	return l;
}

//generate one integer for lowbound and upper bound
int RandonInteger (int lowbound,int upbound)
{
	int onecell;
	onecell=lowbound+rand()%(upbound-lowbound+1);
	return onecell;
}
/*________________________________________________________________*/

double oneLoop(int m, int n, Matrix A,int *b, int *bnew, int *X)
{
	const char *dir1="max";
	const char *dir2="min";
	
	for (int i=0; i<n; ++i) X[i]=0;
	
	//begain generate the random number;
	int lowbound_IP=0;
	int upbound_IP=0;
	double oneN=1;
	for (int k=0;k<n;k++)
	{  
		int nnew=n-k;
		Matrix Anew(m, nnew);
		for(int i = 0; i < m; i++) for(int j = 0; j < nnew; j++) Anew.rowVectors[i].elements[j]=A.rowVectors[i].elements[j+k];
		float l=0;
		
		if (lowbound_IP>upbound_IP)
		{
			X[k]=0;
			oneN=-2;
			
		}
		else {
			upbound_IP=lp_bound_IP( bnew, Anew, m, nnew,l,dir1);
			l=0;
			lowbound_IP=lp_bound_IP( bnew, Anew, m, nnew,l,dir2);
			oneN=oneN*(upbound_IP-lowbound_IP+1);//calculate the sample size;
			//cout << "ONEN IS "<<oneN << endl;
			//  cout<<"lowbound larger than upbound"<<lowbound_IP<<" "<<upbound_IP<<endl;
			if (upbound_IP<lowbound_IP)
			{
				cerr<<"lowbound larger than upbound"<<lowbound_IP<<" "<<upbound_IP<<endl;
				X[k]=0;
			}
			else if (lowbound_IP==upbound_IP) X[k]=lowbound_IP;
			else X[k]=RandonInteger(lowbound_IP, upbound_IP);
			// cout << X[k]<<endl;
			//updat b vector;
			//printf("the updataed b at the %d  step is ", k);
			for(int i = 0; i < m; ++i) 
			{
				bnew[i]=bnew[i]-A.rowVectors[i].elements[k] * X[k];
				//	      cout << bnew[i]<<" ";
			}
			//cout << endl;
		}
	}
	int bcheck[m],bcheckresult[m],RowColcheck=0;
	for (int i=0;i<m;i++)
	{
		bcheck[i]=0;
		for(int j=0;j<n;j++)
		{
			bcheck[i]=bcheck[i]+A.rowVectors[i].elements[j] * X[j];
		}
		//              cout << bcheck[i]<<" "<<b[i]<<endl;
	}
	
	for (int i=0; i<m;i++)  bcheckresult[i]=(bcheck[i]-b[i])*(bcheck[i]-b[i]);
	for(int i = 0; i < m; i++)  RowColcheck += bcheckresult[i];
	
	int elementCheck=0;
	for (int i=0; i<n ; i++) {
		if (X[i]<0) elementCheck++;
	}
	//      cout<<endl<<RowColcheck<<" "<<elementCheck;
	if (RowColcheck > 0 || elementCheck > 0)  oneN=-2;
	return oneN;
}



/**********************************************************************************/
double count;
double succeN;
int main(int argc, char *argv[])
{
	srand(time(0));
	//read A matrix;
	
	int m,n;
	char filename_a[127];
	strcpy(filename_a, argv[1]);
	ifstream in_a(filename_a);
	if(!in_a){
		cerr << "Error on reading the A matrix." << endl;
		exit(0);
	}
	
	in_a >> m>>n;
	Matrix A(m,n);
	cout << "The A matrix you input is:"<<endl;
	for(int i=0;i<m;i++){
		for (int j=0;j<n;j++){
			in_a >> A.rowVectors[i].elements[j];
			cout << A.rowVectors[i].elements[j]<<" ";
		}
		cout<< endl;
	}
	
	//input the observed table X0;
	int b[m];
	int X0[n];
	
	
	char filename_X0[127];
	strcpy(filename_X0, argv[2]);
	ifstream inputX0(filename_X0);
	if(!inputX0){
		cerr << "Error on reading the X0 matrix." << endl;
		exit(0);
	}
	cout << "The observed table is:"<<endl;
	for (int i=0;i<n;i++)
	{
		X0[i]=0; inputX0>> X0[i];
		cout <<X0[i]<<" ";
	}
	cout << endl;
	bMarginCalculator(A, b,X0, m, n);
	
	int bnew[m];
	for (int j=0; j<m; j++) {
		bnew[j]=b[j];
	}
	int X[n+1];
	oneLoop(m, n, A,b,bnew,X);
	cout << "The sampled table is:"<<endl;
	for (int i=0; i<(n); i++) {
		cout << X[i]<<" ";
	}
	cout << endl;
	return 0;
}


















